// ̧قDoxygenpɏĂ܂B
/*! \file *********************************************************************
*
* Atmel Corporation
*
* - ̧		: main.c
* - ߲		: IAR EWAAVR 2.28a/3.10c
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega48/88/168
*
* - pLq	: AVR444 - ATmega48Ƃł3׼DCӰ̊mȂ
*
* - 		: 3׼ڽDCӰ̊mȂATmega48ǂgp邩̗
*
* $Revision: 1.1 $
* $Date: Monday, October 10, 2005 11:15:46 UTC $
******************************************************************************/

#include "BLDC.h"

#include <ioavr.h>
#include <inavr.h>

unsigned char driveTable[6];							//!< e(])iKɑ΂d͒iM\z
unsigned char ADMUXTable[6];							//!< e(])iKɑ΂ADCّI\z
unsigned int startupDelays[STARTUP_NUM_COMMUTATIONS];	//!< nɎgp鐮(])݊Ԓx\z

/*! \brief hgꂽ(])vϐƑxwl
 *
 * ̒l1(])iK̎Ԃ̔ƓłBIIRhgʂhg
 * ÂɊi[ꂽl͍łŋ߂̑ł͂܂B̕ϐ͂f
 * ̂߂R15:R14ڼ޽Ɋi[܂B
 */
__regvar __no_init volatile unsigned int filteredTimeSinceCommutation @14;

/*! \brief ̐(])Ӱ쓮ɏo͂d͒iM
 *
 * ̕ϐ͎̐(])Ӱ쓮ɏo͂d͒iM̗lێ
 * ܂B͂f̂߂R13ڼ޽Ɋi[܂B
 */
__regvar __no_init volatile unsigned char nextDrivePattern @13;

/*! \brief \0̋ɐ
 *
 * \0̋ɐłB\ref EDGE_FALLING ܂ \ref EDGE_RISING
 * ǂ炩ɂȂ蓾܂B
 */
__regvar __no_init volatile unsigned char zcPolarity @ 12;

/*! \brief ̐(])Ŏn܂鐮(])iK
 *
 * ̐(])Ŏn܂鐮(])iKłB͐(])ɉꏊ
 * o܂ۂ̂Ɏgp܂Bf̂߂R11ڼ޽Ɋi[܂B
 */
__regvar __no_init volatile unsigned char nextCommutationStep @11;

volatile unsigned char speedReferenceADC;			//!< O۸ޑxA/Dϊǂݎl
volatile unsigned char shuntVoltageADC = 0;			//!< (do)dA/Dϊǂݎl
volatile unsigned char referenceVoltageADC;			//!< m̊OdA/Dϊǂݎl
volatile unsigned char speedUpdated = FALSE;		//!< OxӰx̍XVL׸
volatile unsigned char currentUpdated = FALSE;		//!< dXVL׸

/*! \brief ۸ъJn_
 *
 * main͎gpSĂ̎Ӌ@\An葱Ăт܂Bʒu
 * ̑SĂ̐(])͊荞ٰ݂ōs܂B
 */
void main(void)
{
  // S⏕n
  ResetHandler();				// ؾČƂɂΉ
  InitPorts();					// ߰ď
  InitTimers();					// ((])ݸނPWMp)/
  InitADC();					// A/Dϊ평
  MakeTables();					// Ӱ쓮\ADCّI\̔z񏉊
  InitAnalogComparator();		// ۸ޔr평

  StartMotor();					// Ӱn菇s

  WatchdogTimerEnable();		// (~op)ޯ Ϗ
  __enable_interrupt();			// S̊荞݋(:OsŊɋĂ邽ߊ{Iɕsv)

  for(;;)
  {
	PWMControl();				// x(PWMޭè ٍXV)
  }
}

/*! \brief ؾČƂɂ铮
 *
 * ̊֐ͳޯ ς֎~ؾĂ̋𔻒f邽߂۸т͎n߂
 * Ă΂܂B
 *
 * ؾČɊ邱Ƃł܂Bޯނ~یƂĎgp
 * ƂA~Ōo邱Ƃł܂BႦ΁AsĎn̎s񐔂
 * EEPROM̕ϐɊi[邱Ƃ\łB鎎s񐔌AOIȑ삪N
 * ܂ŁAӰ͒PɌp₵A]qŒ艻ԕ\ɒ蒅꓾܂B
 */
static void ResetHandler(void)
{
  __eeprom unsigned static int restartAttempts;		// Ďns
  unsigned char tempMCUSR;							// MCUSR̕sv擾pꎞMCUSRϐ

  tempMCUSR = MCUSR;								// MCUSRl擾
  MCUSR = tempMCUSR & ~((1 << WDRF) | (1 << BORF) | (1 << EXTRF) | (1 << PORF));	// MCUSRؾĊ֌WS׸މ
  // ӰnǑ~o邽߂̳ޯޒ~
  __disable_interrupt();							// S̊荞݋֎~
  __watchdog_reset();								// ޯ  ؾ
  WDTCSR |= (1 << WDCE) | (1 << WDE);				// ޯޕύX
  WDTCSR = 0x00;									// ޯދ֎~

  // ؾČƑΉ
  switch (tempMCUSR & ((1 << WDRF) | (1 << BORF) | (1 << EXTRF) | (1 << PORF)))		// ؾČΉ
  {
  case (1 << WDRF):									// ޯ ؾĂŁA
	restartAttempts++;								// Ďnsvis
	if (restartAttempts >= MAX_RESTART_ATTEMPTS)	// eő厎s񐔂ŁA
	{
	  // AႦΖtҋ@ōsĂB
	  for (;;)
	  {

	  }
	}
	// ޯ ؾďɔzuĂB
	break;
  case (1 << BORF):									// do(BOD)ؾĂŁA
	// do(BOD)ؾďɔzuĂB
	break;
  case (1 << EXTRF):								// OؾĂŁA
	restartAttempts = 0;							// Ďnsv평
	// OؾďɔzuĂB
	break;
  case (1 << PORF):									// dONؾĂŁA
	restartAttempts = 0;							// Ďnsv평
	// dONؾďɔzuĂB
	break;
  }
}

/*! \brief o߰ď
 *
 * o߰Ă܂B
 */
static void InitPorts(void)
{
  DRIVE_DDR = (1 << UL) | (1 << UH) | (1 << VL) | (1 << VH) | (1 << WL) | (1 << WH);	// Ӱ쓮p߰ĕo͐ݒ
  DDRD = (1 << PD5);																	// PD5łPWMpPD5o͐ݒ
  DIDR0 = (1 << ADC4D) | (1 << ADC3D) | (1 << ADC2D) | (1 << ADC1D) | (1 << ADC0D);		// ADC͂޼ٓ͂֎~
}

/*! \brief ((])ݸނPWMp)/
 *
 * ̊֐ӰxpPWM/0Ɛ(])ݸޗp/1
 * ܂B
 */
static void InitTimers(void)
{
  // OCR0Al,OC0Bł̈ʑPWM,OuȂ/0n
  TCCR0A = (0 << COM0A1) | (0 << COM0A0) | (1 << COM0B1) | (0 << COM0B0) | (0 << WGM01) | (1 << WGM00);
  TCCR0B = (1 << WGM02) | (0 << CS02) | (0 << CS01) | (1 << CS00);
  OCR0A = PWM_TOP_VALUE;					// l(TOP)l
  TIFR0 = TIFR0;							// /0S荞ݗv׸މ
  TIMSK0 = (0 << TOIE0);					// /0ꊄ荞݋

  TCCR1B = (1 << CS11) | (0 << CS10);		// (])ݸޗp/1W8OuŎn
}

/*! \brief A/Dϊ평
 *
 * ̊֐A/DϊAOd̓ǂݎs܂B
 */
static void InitADC(void)
{
  ADMUX = ADMUX_REF_VOLTAGE;		// Od̎pɐݒ
  ADCSRA = (1 << ADEN) | (1 << ADSC) | (1 << ADIF) | (ADC_PRESCALER_16);	// 16OuA/Dϊ틖,ϊJn
  while (ADCSRA & (1 << ADSC))		// ϊҋ@
  {

  }
  referenceVoltageADC = ADCH;		// Odl擾/ۑ(Iɏ[ϊɑ)

  // PWMpT/C0ł̎N,8OuۯɕύX
  ADCSRA = (1 << ADEN) | (0 << ADSC) | (1 << ADATE) | (1 << ADIF) | (0 << ADIE) | ADC_PRESCALER_8;
  ADCSRB = ADC_TRIGGER_SOURCE;
}

/*! \brief ۸ޔr평
 *
 * ̊֐ͱ۸ޔrߓdopɏ܂B
 */
static void InitAnalogComparator(void)
{
#ifdef ANALOG_COMPARATOR_ENABLE
  ACSR = (0 << ACBG) | (1 << ACI) | (1 << ACIE) | (1 << ACIS1) | (1 << ACIS0);	// ㏸[荞݂ŋ
#endif
}

/*! \brief ޯ Ϗ
 *
 * ̊֐ͳޯ ς~Ďnpɏ܂B
 */
static void WatchdogTimerEnable(void)
{
  __disable_interrupt();				// S̊荞݈ꎞ֎~
  __watchdog_reset();					// ޯ  ؾ

  WDTCSR |= (1 << WDCE) | (1 << WDE);	// ޯޕύX

  WDTCSR = (1 << WDIF) | (1 << WDIE) | (1 << WDE) | (1 << WDP2);	// 0.25s̊荞ݓWDT
  __enable_interrupt();					// S̊荞ݍċ
}

/*! \brief Ӱ쓮\ADCّI\̔z񏉊
 *
 * ̊֐͊e(])iKύXӰ쓮ADCّIɎgp\z
 * ܂B
 */
static void MakeTables(void)
{
#if DIRECTION_OF_ROTATION == CCW			// vŁA
  driveTable[0] = DRIVE_PATTERN_STEP1_CCW;	// v萮(])1iK쓮l
  driveTable[1] = DRIVE_PATTERN_STEP2_CCW;	// v萮(])2iK쓮l
  driveTable[2] = DRIVE_PATTERN_STEP3_CCW;	// v萮(])3iK쓮l
  driveTable[3] = DRIVE_PATTERN_STEP4_CCW;	// v萮(])4iK쓮l
  driveTable[4] = DRIVE_PATTERN_STEP5_CCW;	// v萮(])5iK쓮l
  driveTable[5] = DRIVE_PATTERN_STEP6_CCW;	// v萮(])6iK쓮l

  ADMUXTable[0] = ADMUX_W;					// CCW(])1iKADCّIl
  ADMUXTable[1] = ADMUX_V;					// CCW(])2iKADCّIl
  ADMUXTable[2] = ADMUX_U;					// CCW(])3iKADCّIl
  ADMUXTable[3] = ADMUX_W;					// CCW(])4iKADCّIl
  ADMUXTable[4] = ADMUX_V;					// CCW(])5iKADCّIl
  ADMUXTable[5] = ADMUX_U;					// CCW(])6iKADCّIl
#else										// vŁA
  driveTable[0] = DRIVE_PATTERN_STEP1_CW;	// v萮(])1iK쓮l
  driveTable[1] = DRIVE_PATTERN_STEP2_CW;	// v萮(])2iK쓮l
  driveTable[2] = DRIVE_PATTERN_STEP3_CW;	// v萮(])3iK쓮l
  driveTable[3] = DRIVE_PATTERN_STEP4_CW;	// v萮(])4iK쓮l
  driveTable[4] = DRIVE_PATTERN_STEP5_CW;	// v萮(])5iK쓮l
  driveTable[5] = DRIVE_PATTERN_STEP6_CW;	// v萮(])6iK쓮l

  ADMUXTable[0] = ADMUX_U;					// CW(])1iKADCّIl
  ADMUXTable[1] = ADMUX_V;					// CW(])2iKADCّIl
  ADMUXTable[2] = ADMUX_W;					// CW(])3iKADCّIl
  ADMUXTable[3] = ADMUX_U;					// CW(])4iKADCّIl
  ADMUXTable[4] = ADMUX_V;					// CW(])5iKADCّIl
  ADMUXTable[5] = ADMUX_W;					// CW(])6iKADCّIl
#endif
  // n\
  startupDelays[0] = 200;					// n1iڒx(20ms)
  startupDelays[1] = 150;					// n2iڒx(15ms)
  startupDelays[2] = 100;					// n3iڒx(10ms)
  startupDelays[3] = 80;					// n4iڒx(8ms)
  startupDelays[4] = 70;					// n5iڒx(7ms)
  startupDelays[5] = 65;					// n6iڒx(6.5ms)
  startupDelays[6] = 60;					// n7iڒx(6ms)
  startupDelays[7] = 55;					// n8iڒx(5.5ms)
}

/*! \brief Ӱn菇s
 *
 * ̊KӰm̈ʒu֌Œ艻A/1ꊄ荞݂ɂĐ䂳
 * (])菇n߂܂B
 */
static void StartMotor(void)
{
  unsigned char i;

  SET_PWM_COMPARE_VALUE(STARTUP_PWM_COMPARE_VALUE);		// nޭè(PWM)
  nextCommutationStep = 0;								// 񐮗(])iKԍ

  // Oʒut
  DRIVE_PORT = driveTable[nextCommutationStep];			// (])1iK쓮Jn
  StartupDelay(STARTUP_LOCK_DELAY);						// ]qŒ艻x
  nextCommutationStep++;								// p(])iKԍis
  nextDrivePattern = driveTable[nextCommutationStep];	// (])쓮lXV

  for (i = 0; i < STARTUP_NUM_COMMUTATIONS; i++)		// w񐔕n菇s
  {
	DRIVE_PORT = nextDrivePattern;						// ̐(])iK쓮Jn
	StartupDelay(startupDelays[i]);						// Ή(])Ԓx
	ADMUX = ADMUXTable[nextCommutationStep];			// ΉiKpADCّI
	zcPolarity = nextCommutationStep & 0x01;			// 0ɐݒ(iKԍLSB(/))
	nextCommutationStep++;								// pɐ(])iKԍis
	if (nextCommutationStep >= 6)						// ŏIiKzŁA
	{
	  nextCommutationStep = 0;							// iKԍ1iKɕύX
	}
	nextDrivePattern = driveTable[nextCommutationStep];	// (])쓮lXV
  }

  // mȂ(])֐؂ւ
  TCNT1 = 0;											// /1l
  TIMSK1 = (1 << OCIE1A);								// /1rAv荞݋
  // hgςݐ(])v평(=ŏIiKԒxԁ2)
  filteredTimeSinceCommutation = startupDelays[STARTUP_NUM_COMMUTATIONS - 1] * (STARTUP_DELAY_MULTIPLIER  / 2);
}

/*! \brief /0ꊄ荞ݏ(0oɎgp)
 *
 * ̊荞ݏٰ݂͏~vPWMv킪ɒB閈ɌĂ΂܂B
 * 荞݂N̂ƓɁA(L)قłA/DϊIɋN
 * ܂B0oɎgp܂B
 *
 * 0̎ۂł͒O̐(])̎Ԃi[A/1̐(]
 * )̏uԂŋN悤ɍ\܂B
 */
#pragma vector=TIMER0_OVF_vect
__interrupt void MotorPWMBottom()
{
  unsigned char temp;

  // A/DϊN֎~B͌ł̎蓮̎ŕsق̎悳̂
  // 邽߁AōsȂ΂Ȃ܂B݂̎Nϊ͌pĂ܂B
  ADCSRA &= ~((1 << ADATE) | (1 << ADIE));		// NƊ荞݂֎~

  while (!(ADCSRA & (1 << ADIF)))				// NA/Dϊҋ@
  {

  }
  temp = ADCH;									// tNdA/Dϊl擾
  // 0LŁA
  if (((zcPolarity == EDGE_RISING) && (temp > ADC_ZC_THRESHOLD)) || ((zcPolarity == EDGE_FALLING) && (temp < ADC_ZC_THRESHOLD)))
  {
	unsigned int timeSinceCommutation;			// O̐(])̌oߎ(T/C1l)

	timeSinceCommutation = TCNT1;				// O̐(])̌oߎԎ擾
	TCNT1 = COMMUTATION_CORRECTION;				// /1((])_vJn)
	// hgς1/2(])ԊuXV(擾lƉߋhglvZ)
	filteredTimeSinceCommutation = (COMMUTATION_TIMING_IIR_COEFF_A * timeSinceCommutation
								  + COMMUTATION_TIMING_IIR_COEFF_B * filteredTimeSinceCommutation)
								 / (COMMUTATION_TIMING_IIR_COEFF_A + COMMUTATION_TIMING_IIR_COEFF_B);
	OCR1A = filteredTimeSinceCommutation;		// (])_rAƂĐݒ
	speedUpdated = TRUE;						// xXVL׸ސݒ
	SET_TIMER1_INT_COMMUTATION;					// /1rA荞݋
	CLEAR_ALL_TIMER1_INT_FLAGS;					// /1S荞ݗv׸މ
	DISABLE_ALL_TIMER0_INTS;					// /0S荞݋֎~(Ӑ}͈ꊄ荞݋֎~)

	// x
	while (ADCSRA & (1 << ADSC))				// A/Dϊҋ@(isA/DϊȂƂ̊mF)
	{
	}
	ADMUX = ADMUX_SPEED_REF;					// xp̕ϊd,ADCّI
	ADCSRA |= (1 << ADSC);						// xA/DϊJn
	while((ADCSRA & (1 << ADSC)))				// A/Dϊҋ@
	{
	}
	speedReferenceADC = ADCH;					// xA/Dϊl擾/XV

	// Od
	ADMUX = ADMUX_REF_VOLTAGE;					// Odp̕ϊd,ADCّI
	ADCSRA |= (1 << ADSC);						// OdA/DϊJn
	while((ADCSRA & (1 << ADSC)))				// A/Dϊҋ@
	{
	}
	referenceVoltageADC = ADCH;					// OdA/Dϊl擾/XV

	// A/Dϊ荞݂ł̓d苖
	ADMUX = ADMUX_CURRENT;						// dp̕ϊd,ADCّI
	ADCSRA |= (1 << ADATE) | (1 << ADIE) | ADC_PRESCALER;	// N,荞݋,ʏOu(=1/8)ɕύX
  }
  else											// 0ȂŁA
  {
	unsigned char tempADMUX;

	tempADMUX = ADMUX;							// d,ADCوꎞޔ

	// d(0ô߁A蓮)
	while (ADCSRA & (1 << ADSC))				// A/Dϊҋ@(isA/DϊȂƂ̊mF)
	{
	}
	ADMUX = ADMUX_CURRENT;						// dp̕ϊd,ADCّI
	ADCSRA |= (1 << ADSC);						// OdA/DϊJn
	while((ADCSRA & (1 << ADSC)))				// A/Dϊҋ@
	{
	}
	shuntVoltageADC = ADCH;						// d((do)d)A/Dϊl擾/XV
	currentUpdated = TRUE;						// dXVL׸ސݒ

	ADMUX = tempADMUX;							// ϊd,ADCى
	ADCSRA |= (1 << ADATE) | (1 << ADIE) | ADC_PRESCALER;	// N,荞݋,ʏOu(=1/8)ɕύX
  }
}

/*! \brief (])Ǝ0o
 *
 * ̊荞ݏٰ݂͐(])\肳Ă鎞ŐmɋN܂B
 * (])̏uԂɎsA(])0oԂ̒x(Ԋu)𑪒肷邽
 * ߂/0ؾĂ܂B
 *
 * (])͒ZԁASĂ̑ő傫ȏuJڂNAɌ0
 * oN܂B]Čǂȓǂݎ邽߂ɁA0o
 * h~Ԃgp܂B/1̔rBgpĎs܂Bw肵
 * h~Ԍɂ̔rN悤ɐݒ肳܂B/1rBv
 * 荞ݏ0o܂B
 */
#pragma vector=TIMER1_COMPA_vect
__interrupt void Commutate()
{
  DRIVE_PORT = nextDrivePattern;				// ̐(])iK֋쓮lύX
  TCNT1 = 0;									// /1
  zcPolarity = nextCommutationStep & 0x01;		// 0oɐXV
  // 0oh~vn
  CLEAR_ALL_TIMER1_INT_FLAGS;					// /1S荞ݗv׸މ
  OCR1B = ZC_DETECTION_HOLDOFF_TIME_US;			// (])0o֎~Ԑݒ
  SET_TIMER1_INT_HOLDOFF;						// /1rBv荞݋
  __watchdog_reset();							// ޯ  ؾ
}

/*! \brief 0o
 *
 * ̊荞ݏٰ݂͐(])0oh~Ԃ߂ɋN
 * B0oɎgpׂA/Dϊǂݎ߂ɁA/1̑S
 * ݂֎~A/0̈(PWM)荞݂܂B
 */
#pragma vector=TIMER1_COMPB_vect
__interrupt void EnableZCDetection()
{
  CLEAR_ALL_TIMER0_INT_FLAGS;					// /0S荞ݗv׸މ
  CLEAR_ALL_TIMER1_INT_FLAGS;					// /1S荞ݗv׸މ
  SET_TIMER0_INT_ZC_DETECTION;					// /0ꊄ荞݋(0op)
  DISABLE_ALL_TIMER1_INTS;						// /1S荞݋֎~

  ADMUX = ADMUXTable[nextCommutationStep];		// Ή(])iK㎥ADCّI(0op)
  while (!(ADCSRA & (1 << ADIF)))				// A/Dϊҋ@(isA/DϊȂƂ̊mF)
  {
  }
  ADCSRA &= ~(1 << ADIE);						// A/Dϊ荞݋֎~
  ADCSRA |= (1 << ADSC) | (1 << ADATE);			// ϊJn,N(T/C0ł0op)

  // Rotate commutation step counter.
  nextCommutationStep++;						// pɐ(])iKԍis
  if (nextCommutationStep >= 6)					// ŏIiKzŁA
  {
    nextCommutationStep = 0;					// iKԍ1iKɕύX
  }
  nextDrivePattern = driveTable[nextCommutationStep];	// (])쓮lXV
}

/* \brief dɎgpA/Dϊ荞ݏٰ
 *
 * ̊荞ݏٰ݂͓d肪PWMpv(T/C0)ɂĎN
 * ɂ܂BlP \ref shuntVoltageADC ֕ʂA
 * \ref currentUpdated ׸ނݒ肳A/0(PWMv)荞ݗv
 * ނ܂B
 */
#pragma vector=ADC_vect
__interrupt void CurrentMeasurementComplete()
{
  shuntVoltageADC = ADCH;						// d((do)d)A/Dϊl擾/XV
  currentUpdated = TRUE;						// dXVL׸ސݒ
  CLEAR_ALL_TIMER0_INT_FLAGS;					// /0S荞ݗv׸މ
}

/*! \brief ޯފ荞
 *
 * ̊荞ݏٰ݂Ӱ~̂߂ɳޯ ς޲ؾĂOɌĂ
 * ܂BPɋ쓮֎~邾łA̍Ƃͳޯ ؾĂɐ旧čs
 * Ȃ΂Ȃ炸Asؓϐւ̋L̂悤Ȃ̂͂ōsƂ
 * ܂B
 */
#pragma vector=WDT_vect
__interrupt void WatchdogISR()
{
  DISABLE_DRIVING;		// Ӱւ̑Sd͐ؒf
  for(;;)				// 㑱鳫ޯ ؾđ҂
  {
    ;
  }
}

/*! \brief ߓd荞
 *
 * ̊荞ݏٰ݂͉ߓdԂmꂽӰւ̓d͂ؒf܂B
 */
#ifdef ANALOG_COMPARATOR_ENABLE
#pragma vector=ANA_COMP_vect
__interrupt void OverCurrentISR()
{
  DISABLE_DRIVING;		// Ӱւ̑Sd͐ؒf
  for(;;)				// ޯފ荞ݑ҂
  {
    ;
  }
}
#endif

/*! \brief nɎgpx
 *
 * ̊֐͎n菇̒xɎgp܂Bxdelay~STARTUP_DELAY_M
 * ULTIPLIERsƓłB/̊֐Ŏgp邽߁AmȂ삪
 * 쎞ɌČĂ΂Ă͂Ȃ܂B
 */
void StartupDelay(unsigned int delay)
{
  CLEAR_ALL_TIMER1_INT_FLAGS;						// /1S荞ݗv׸މ
  do
  {
	TCNT1 = 0xFFFF - STARTUP_DELAY_MULTIPLIER;		// /1100svlݒ
	while (!(TIFR1 & (1 << TOV1)))					// /1ҋ@
	{
	}
	CLEAR_ALL_TIMER1_INT_FLAGS;						// /1S荞ݗv׸މ
	delay--;										// xv팸
  } while (delay);									// wx܂Ōp
}

#ifdef SPEED_CONTROL_CLOSED_LOOP
/*! \brief xݒ_ƏdɊPWMޭè ق̐
 *
 * ̊֐͑x䕔Ɠd䕔ĂԂƂPWMޭè ق𐧌䂵܂Bx
 * 䕔Mޭè ق֒ړKp܂Bd䕔M͍őޭè ق
 * ̂Ɏgp܂B
 */
static void PWMControl(void)
{
  signed int speedCompensation;									// xpޭè ٕ␳l
  static unsigned char currentCompensation = 0;
  static signed int duty = STARTUP_PWM_COMPARE_VALUE;			// ޭè ْl

 if (speedUpdated)												// xXVLŁA
  {
	speedCompensation = SpeedControl();							// xpޭè ٕ␳l擾
	speedUpdated = FALSE;										// xXVL׸މ
	duty += speedCompensation;									// ޭè ْl␳
  }

  if (currentUpdated)											// dXVLŁA
  {
	currentCompensation = CurrentControl();						// dWl擾
	currentUpdated = FALSE;										// dXVL׸މ
  }

  // ޭè ق𐧌͈͓Ɉێ
  if (duty < MIN_PWM_COMPARE_VALUE)								// ŏeޭè(PWMprl)ŁA
  {
	duty = MIN_PWM_COMPARE_VALUE;								// ŏeޭè قɕύX
  }
  if (duty > (MAX_PWM_COMPARE_VALUE - currentCompensation))		// d⏞ɍő勖eޭè(PWMprl)z
  {
	duty = MAX_PWM_COMPARE_VALUE - currentCompensation;			// d⏞tő勖eޭè قɕύX
  }
  SET_PWM_COMPARE_VALUE((unsigned char)duty);					// Vޭè (PWMl)ݒ
}
#endif

#ifdef SPEED_CONTROL_OPEN_LOOP
static void PWMControl(void)
{
  // (x蒼ɍs)VKx肪sꂽꍇɂޭè قXVB
  if (speedUpdated)
  {
	// xlޭè قvZ
	SET_PWM_COMPARE_VALUE(MIN_PWM_COMPARE_VALUE + speedReferenceADC * (MAX_PWM_COMPARE_VALUE - MIN_PWM_COMPARE_VALUE) / ADC_RESOLUTION);
  }
}
#endif

/*! \brief dCIRPMł̌󑬓xvZ
 *
 * ̊֐ \ref filteredTimeSinceCommutation S̕ϐ番̉]
 * dCIȌ󑬓xvZ܂B
 */
static unsigned long CalculateSpeed()
{
  unsigned int filteredTimeSinceCommutationCopy;	// 荞݋֎~ԂŏƂ邽߂hgς1/2(])Ԋuʒl
  unsigned long rotationPeriod;						// dCI1]
  unsigned long speed;								// dCIȉ]x(RPM)

  /*
  \ref filteredTimeSinceCommutation 񕪒fű̂ۏ؂邽߂Ɋ荞݂֎~܂B
  */
  __disable_interrupt();			// S̊荞݈ꎞ֎~
  filteredTimeSinceCommutationCopy = filteredTimeSinceCommutation;			// hgς1/2(])Ԋul
  __enable_interrupt();				// S̊荞ݍċ

  /*
  filteredTimeSinceCommutation1/2(])ԊulłBSȓdCI1]
  ɂ12(2~6){Ȃ΂Ȃ܂B
  */
  rotationPeriod = (unsigned long)filteredTimeSinceCommutationCopy * 12;	// dCI1]擾
  speed = (TICKS_PER_MINUTE / rotationPeriod);								// dCIRPM擾
  return speed;																// ]x(RPM)ƋɕA
}

/*! \brief dCIRPMł̑xݒ_vZ
 *
 * ̊֐speedReferenceADCS̕ϐ瑬xݒ_vZ܂B
 *
 * ̎ł$00`$FF̑xl \ref MIN_SPEED  \ref MAX_SPEED ɂ
 * ݒ肳鋖e\ȑx͈͓ŒIɊ蓖Ă܂B
 */
static unsigned long CalculateSpeedSetpoint()
{
  return (MIN_SPEED + ((MAX_SPEED - MIN_SPEED) * (unsigned int)speedReferenceADC) / ADC_RESOLUTION);
}

/*! \brief dvZ
 *
 * ̊֐ \ref shuntVoltageADC S̕ϐmAPʂŏdvZ܂BAR
 * EFdω⏞邽߂Ɋm̊Odgp܂B
 */
static unsigned int CalculateCurrent()
{
  unsigned long ADCref;		// 256{dW
  unsigned int current;		// mAPʏd

  // (Ӱdkڂ)AREF݂̓dm̊dp(mAPʂ)vZ܂B
  ADCref = EXTERNAL_REF_VOLTAGE * 256UL / referenceVoltageADC;
  // (do)Rʂd(mAPʂ)vZ܂B
  current = (unsigned int)((shuntVoltageADC * ADCref * 1000UL / 256UL) / SHUNT_RESISTANCE);
  return current;			// d(mA)lƋɕA
}

/*! \brief x
 *
 * ̊֐͊ȒPP()xi߂܂Bޭè ق(e0oł)
 * VKx肪pӂ鎞ɂXV܂B]ĎԊԊu͉ςŁÂP
 * P͈̌nɑ΂PƈقȂAxɏ]܂B
 */
static signed int SpeedControl(void)
{
  unsigned long speedSetpoint;							// xݒ_(RPM)
  unsigned long currentSpeed;							// ݂̓dCI]x(RPM)
  signed long speedError;								// ݒƎۂ̑x
  signed long dutyChange;								// Cޭè ْl

  speedSetpoint = CalculateSpeedSetpoint();				// xݒ_(RPM)擾
  currentSpeed = CalculateSpeed();						// ݂̓dCI]x(RPM)擾
  speedError = (speedSetpoint - currentSpeed);			// ݒƎۂ̑x擾
  dutyChange = speedError * P_REG_K_P / P_REG_SCALING;	// ޭè ٕ␳l擾
  return dutyChange;									// ޭè ٕ␳lƋɕA
}

/*! \brief d
 *
 * ̊֐͑xɌĂ΂܂BxɂČvZėvꂽޭè
 * قp\ŁÅ֐ɂ͓dxɗ܂邱Ƃۏ؂邽߂ޭè
 * ق␳ӔC܂B
 */
static unsigned char CurrentControl(void)
{
  unsigned int current;						// mAPʏd
  unsigned int overCurrentCorrection = 0;	// dW

  current = CalculateCurrent();				// mAPʏd擾

  if (current > CURRENT_LIMITER_CRITICAL)	// dzŁA
  {
	DRIVE_PORT = 0x00;						// Ӱ쓮io͑SOFFݒ
	for (;;)
	{
	  // ~Aޯ ς޲ؾĂ܂B
	}
  }

  if (current > CURRENT_LIMITER_START)		// dJn_zŁA
  {
	overCurrentCorrection = (current - CURRENT_LIMITER_START) * CURRENT_LIMITER_FACTOR;		// dW擾
  }
  if (overCurrentCorrection > 255)			// dW͈͉zŁA
  {
	return 255;								// dWƋɕA
  }
  return overCurrentCorrection;				// ΉdWƋɕA
}

/*! \mainpage
 * \section Intro 
 * AVR444pLqpĳް\́A֐AϐA`A񋓁A^`̎
 * łB
 *
 * \section CI ߲׏
 * ̿ĳIAREmbedded Workbench 4.11Apɏ܂B
 *
 * ۼުĂ쐬ɂ́A:
 * <ol>
 * <li> ۼުĂmain.çقǉĂB
 * <li> processor configurationdeviceATmega48,ATmega88,܂ATmega168
 * IłB
 * <li> Enable bit definitions in I/O include filesĂB
 * <li> "C/C++ compiler->Code->Register utilization"őS̕ϐpŒ艻Ƃ5
 * ڼ޽(R11`15)IĂB
 * <li> ō\̂߂High optimization on speed(xł̍œK)
 * ܂B
 * </ol>
 *
 * \section DI ޲
 * ܂߂ꂽ ނATmega48/88/168pɏĂ܂B
 */


